[01背包] 洛谷P1417 烹调方案(价值变换问题)

题目

LP1417

思路

本题乍一看是一道简单的01背包,实则不是,因为物品的价值会随着枚举顺序变换。因此应该选择最优的枚举顺序,使物品价值的损失最少,从而得到最优解。


数学证明:(by tinylic)

如果没有b[i]这个属性的话就是明显的01背包问题。

现在考虑相邻的两个物品x,y。假设现在已经耗费p的时间,那么分别列出先做x,y的代价:
a[x]-(p+c[x])*b[x]+a[y]-(p+c[x]+c[y])*by
a[y]-(p+c[y])*b[y]+a[x]-(p+c[y]+c[x])*bx
对这两个式子化简,得到①>②的条件是c[x]*b[y] < c[y]*b[x].
发现只要满足这个条件的物品对(x,y),x在y前的代价永远更优。
因此可以根据这个条件进行排序,之后就是简单的01背包了。

代码

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <algorithm>
#define ll long long
#define _for(i,a,b) for(int i = (a); i<(b); i++)
#define _rep(i,a,b) for(int i = (a); i<=(b); i++)
using namespace std;

const int maxn = 50 + 10;
const int maxt = 100000 + 10;
int t,n;
ll d[maxt];

struct node {
    ll a, b, c;
}A[maxn];

bool cmp(node a, node b) {
    return a.c * b.b < b.c * a.b;
}

int main() {
    scanf("%d%d", &t, &n);
    _rep(i, 1, n) scanf("%lld", &A[i].a);
    _rep(i, 1, n) scanf("%lld", &A[i].b);
    _rep(i, 1, n) scanf("%lld", &A[i].c);

    sort(A + 1, A + n + 1, cmp);

    _rep(i, 1, n)
        for (int tt = t; tt >= 0; tt--)
            if (tt + A[i].c <= t)
                d[tt + A[i].c] = max(d[tt + A[i].c], d[tt] + A[i].a - (tt + A[i].c)*A[i].b);

    ll ans = 0;
    _rep(i, 0, t) ans = max(ans, d[i]);
    printf("%lld\n", ans);

    return 0;
}
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值